# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_core.ipynb.

# %% auto 0
__all__ = ['Variable', 'Variables', 'Dataset', 'Instrument', 'Mission']

# %% ../nbs/00_core.ipynb 1
from pydantic import ConfigDict
from pydantic.dataclasses import dataclass
from datetime import datetime

# %% ../nbs/00_core.ipynb 3
@dataclass(config=ConfigDict(extra='allow'))
class Variable:
    name: str = None
    description: str = None
    unit: str = None
    timerange: list[datetime] = None
    
@dataclass
class Variables:
    timerange: list[datetime] = None
    variables: dict[str, Variable] = None
    def add_variable(self, variable: Variable):
        self.variables[variable.name] = variable

# %% ../nbs/00_core.ipynb 5
@dataclass
class Dataset(Variables):
    name: str = None

# %% ../nbs/00_core.ipynb 7
@dataclass
class Instrument:
    name: str
    datasets: dict[str, Dataset] = None

    def add_dataset(self, dataset: Dataset):
        self.datasets[dataset.name] = dataset


@dataclass
class Mission:
    name: str
    """Name of the mission"""
    instruments: dict[str, Instrument] = None
    datasets: dict[str, Dataset] = None

    def add_instrument(self, instrument: Instrument):
        self.instruments[instrument.name] = instrument
